/*
  Melody
  
  created 21 Jan 2010
  modified 30 Aug 2011
  by Tom Igoe

  modified 1 May 2021
  by Whitney O'Reardon
*/

#include "pitches.h"

const int speaker = 11;

// notes in the melody:
int melody[] = {
  NOTE_B3, NOTE_C6, NOTE_B5, NOTE_D6, NOTE_A3, NOTE_B3,
  
  NOTE_B5, NOTE_G5, NOTE_B4, NOTE_D5, NOTE_C5, NOTE_B4,
  NOTE_B4, NOTE_A3, NOTE_B3, NOTE_C4, NOTE_D4, NOTE_B3, NOTE_C5, NOTE_B4,
  
  NOTE_A4, NOTE_C6, NOTE_B5, NOTE_G5, NOTE_B5, NOTE_A5, NOTE_G5, NOTE_FS5,
  NOTE_G5, NOTE_G4, NOTE_D5, NOTE_E5, NOTE_D5, NOTE_C5, NOTE_D5, NOTE_G4, NOTE_D5,
  NOTE_E5, NOTE_D5, NOTE_C5, NOTE_D5, NOTE_G3, NOTE_B4, NOTE_A4, NOTE_G4, NOTE_FS4, NOTE_G4
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4, 4, 1, 4, 4, 1,
  
  4, 4, 2, 2, 8, 2,
  4, 4, 2, 8, 8, 2, 8, 2,
  
  4, 4, 1, 4, 4, 2, 8, 8,
  1, 4, 4, 2, 8, 8, 4, 4, 8,
  2, 8, 8, 4, 4, 8, 1, 8, 8, 1
};

void setup() {
}

void loop() {
  // iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < 48; thisNote++) {

    // to calculate the note duration, take one second divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000 / noteDurations[thisNote];
    tone(speaker, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(speaker);
  }
  delay(10000);
}
